











from blf import size as blfSize
from blf import dimensions as blfDimen
from math import floor

from ... win import Window
from ... util.types import RnaString, LocalHistory



LONGEST_TITLE = "Color: Window Title Close Button Hover Hold"

## _editor_ ##
class SettingEditor(Window):
    __slots__ = 'active_tab'

    name = 'Settings'

    @staticmethod
    def r_size_default():
        blfSize(FONT0, D_SIZE['font_main'])
        border_outer = SIZE_border[0]
        border_inner = SIZE_border[1]
        widget_rim = SIZE_border[3]
        border = SIZE_dd_border[0]
        border_outer_2 = border_outer + border_outer

        return (
            border_outer_2 + AreaSettingList.r_width_default() + border_inner + (SIZE_dd_border[0] + widget_rim + widget_rim) * 2 + (SIZE_block[1] + D_SIZE['font_main_dx']) * 2 + SIZE_widget[0] + floor(blfDimen(FONT0, LONGEST_TITLE)[0]) + SIZE_block[2] + D_SIZE['widget_width'],
            border_outer_2 + border + border + D_SIZE['widget_full_h'] + border_inner + P.SettingEditor.area_height * SIZE_widget[0] + (border + widget_rim + widget_rim) * 2
        )
        #| (538, 543)
    @staticmethod
    def r_size_default_area_tab():
        blfSize(FONT0, D_SIZE['font_main'])
        border_inner = SIZE_border[1]
        widget_rim = SIZE_border[3]
        border = SIZE_dd_border[0]

        return (
            (SIZE_dd_border[0] + widget_rim + widget_rim) * 2 + (SIZE_block[1] + D_SIZE['font_main_dx']) * 2 + SIZE_widget[0] + floor(blfDimen(FONT0, LONGEST_TITLE)[0]) + SIZE_block[2] + D_SIZE['widget_width'],
            P.SettingEditor.area_height * SIZE_widget[0] + (border + widget_rim + widget_rim) * 2
        )
        #|
    @staticmethod
    def r_size_default_area_header():
        blfSize(FONT0, D_SIZE['font_main'])
        widget_rim = SIZE_border[3]

        return (
            AreaSettingList.r_width_default() + SIZE_border[1] + (SIZE_dd_border[0] + widget_rim + widget_rim) * 2 + (SIZE_block[1] + D_SIZE['font_main_dx']) * 2 + SIZE_widget[0] + floor(blfDimen(FONT0, LONGEST_TITLE)[0]) + SIZE_block[2] + D_SIZE['widget_width'],
            SIZE_dd_border[0] * 2 + D_SIZE['widget_full_h']
        )
        #|

    def fin_callfront(self):
        self.areas[
            # <<< 1copy (0ed_SettingEditor_AREAIND_header,, $$)
            0
            # >>>
        ].local_tabhistory.kill()
        #|

    def init(self, boxes, blfs):
        self.active_tab = ("system",)

        # /* 0ed_SettingEditor_init
        border_outer = SIZE_border[0]
        border_inner = SIZE_border[1]
        widget_rim = SIZE_border[3]
        border = SIZE_dd_border[0]
        L0 = self.box_win.L + border_outer
        T0 = self.box_win.title_B - border_outer
        B0 = T0 - border - border - D_SIZE['widget_full_h']
        T1 = B0 - border_inner

        BB = T1 - P.SettingEditor.area_height * SIZE_widget[0] - (border + widget_rim + widget_rim) * 2
        d2 = (SIZE_dd_border[0] + widget_rim + widget_rim) * 2
        offset_x = SIZE_block[1] + D_SIZE['font_main_dx']
        # */

        area1 = AreaSettingList(self, L0, T1) # set_size already
        L1 = area1.box_area.R + border_inner
        RR = L1 + d2 + offset_x * 2 + SIZE_widget[0] + floor(blfDimen(FONT0, LONGEST_TITLE)[0]
            ) + SIZE_block[2] + D_SIZE['widget_width']

        self.areas = [
            AreaSettingHeader(self, L0, RR, B0, T0, r_size_default=self.r_size_default_area_header),
            area1,
            AreaBlockTabSettingEditor(self, L1, RR, BB, T1, r_size_default=self.r_size_default_area_tab)
        ]
        self.areas[0].history_init()
        self.areas[2].init_tab(self.active_tab, push=False)
        #|
    def upd_size_areas(self):
        # a2 = self.areas[2]
        # if hasattr(a2, "upd_size_fix_canvas_init"): a2.upd_size_fix_canvas_init()

        # <<< 1copy (0ed_SettingEditor_init,, $$)
        border_outer = SIZE_border[0]
        border_inner = SIZE_border[1]
        widget_rim = SIZE_border[3]
        border = SIZE_dd_border[0]
        L0 = self.box_win.L + border_outer
        T0 = self.box_win.title_B - border_outer
        B0 = T0 - border - border - D_SIZE['widget_full_h']
        T1 = B0 - border_inner

        BB = T1 - P.SettingEditor.area_height * SIZE_widget[0] - (border + widget_rim + widget_rim) * 2
        d2 = (SIZE_dd_border[0] + widget_rim + widget_rim) * 2
        offset_x = SIZE_block[1] + D_SIZE['font_main_dx']
        # >>>

        self.areas[1].upd_size(L0, T1)
        L1 = self.areas[1].box_area.R + border_inner
        RR = L1 + d2 + offset_x * 2 + SIZE_widget[0] + floor(blfDimen(FONT0, LONGEST_TITLE)[0]
            ) + SIZE_block[2] + D_SIZE['widget_width']

        self.areas[0].upd_size(L0, RR, B0, T0)
        self.areas[2].upd_size(L1, RR, BB, T1)

        # if hasattr(a2, "upd_size_fix_canvas_end"): a2.upd_size_fix_canvas_end()
        #|

    def evt_redo(self):

        kill_evt_except()
        if PREF_HISTORY.index + 1 >= len(PREF_HISTORY.array):
            report('Currently in last step')
            return

        try:
            PREF_HISTORY.index += 1
            his = PREF_HISTORY.array[PREF_HISTORY.index]
            his.set_value(his.value_to)
            report(f'Redo {his.info} | value to: {his.value_to}')
        except Exception as e:

            report('Unexpected error, please report to the author')
        #|
    def evt_undo(self):

        kill_evt_except()
        his = PREF_HISTORY.array[PREF_HISTORY.index]
        if PREF_HISTORY.index == 0:
            report('Currently in first step')
            return
        try:
            his.set_value(his.value_from)
            PREF_HISTORY.index -= 1
            report(f'Undo {his.info} | value from: {his.value_from}')
        except Exception as e:

            report('Unexpected error, please report to the author')
        #|
    def evt_search(self):

        kill_evt_except()
        a = self.areas[0]
        a.buttons[a.ITEM_IDS["search"]].fn()
        #|

    @staticmethod
    def open_search(
                    tx = "",
                    use_pos = False,
                    use_fit = False,
                    match_case = False,
                    match_whole_word = True,
                    match_end = 0,
                    true_ids = {"id", "keymap"}):

        w = SettingEditor(id_class="SettingEditor", use_pos=use_pos, use_fit=use_fit, pos_offset=(-150, 15))
        a = w.areas[2]
        a.init_tab(("search",))
        w.upd_data()
        a.items[0].set_properties(
            tx = tx,
            match_case = match_case,
            match_whole_word = match_whole_word,
            match_end = match_end,
            true_ids = true_ids)

        for e in W_DRAW.copy():
            if e.__class__.__name__.find("DropDown") != -1:
                bring_draw_to_top_safe(e)
        #|
    #|
    #|

class KeymapEditor(Window):
    __slots__ = 'keyinfo', 'km', 'keyinfo_check_repeat'

    name = 'Keymap'

    @ staticmethod
    def r_size_default():
        border_outer_2 = SIZE_border[0] * 2
        widget_rim = SIZE_border[3]
        border = SIZE_dd_border[0]
        return (
            border_outer_2 + round(D_SIZE["widget_width"] * 3.731),
            border_outer_2 + (border + widget_rim + widget_rim) * 2 + SIZE_widget[0] * 8 + min(SIZE_widget[2], SIZE_widget[0]) + SIZE_border[1] * 2 + AreaKeymapCatch.r_height(None, None) + (border + widget_rim + widget_rim) * 2 + SIZE_widget[0] * 4
        )
        #|

    def init(self, boxes, blfs):
        # /* 0ed_KeymapEditor_init
        editor_width = round(D_SIZE["widget_width"] * 3.731)
        row_count_info = 8
        row_count_info_check_repeat = 4
        border_outer = SIZE_border[0]
        border_inner = SIZE_border[1]
        widget_rim = SIZE_border[3]
        border = SIZE_dd_border[0]
        LL = self.box_win.L + border_outer
        T0 = self.box_win.title_B - border_outer
        RR = LL + editor_width
        B0 = T0 - (border + widget_rim + widget_rim) * 2 - SIZE_widget[0] * row_count_info - min(SIZE_widget[2], SIZE_widget[0])
        T1 = B0 - border_inner
        B1 = T1 - AreaKeymapCatch.r_height(None, None)
        T2 = B1 - border_inner
        B2 = T2 - (border + widget_rim + widget_rim) * 2 - SIZE_widget[0] * row_count_info_check_repeat
        # */

        kw = Window.INIT_DATA
        trigger_id = kw["trigger_id"]
        trigger_index = kw["trigger_index"]
        self.km = KEYMAPS[trigger_id]

        self.keyinfo = r_keyinfo(P.keymaps.bl_rna.properties[trigger_id], trigger_id, trigger_index)
        self.keyinfo_check_repeat = ""

        a0 = AreaStringXYPre(self, input_text=self.keyinfo)
        a0.upd_size(LL, RR, B0, T0)
        a1 = AreaKeymapCatch(self, LL, RR, B1, T1, trigger_id, trigger_index)
        a2 = AreaStringXYPre(self, input_text="")
        a2.upd_size(LL, RR, B2, T2)
        self.areas = [a0, a1, a2]
        #|
    def upd_size_areas(self):
        # <<< 1copy (0ed_KeymapEditor_init,, $$)
        editor_width = round(D_SIZE["widget_width"] * 3.731)
        row_count_info = 8
        row_count_info_check_repeat = 4
        border_outer = SIZE_border[0]
        border_inner = SIZE_border[1]
        widget_rim = SIZE_border[3]
        border = SIZE_dd_border[0]
        LL = self.box_win.L + border_outer
        T0 = self.box_win.title_B - border_outer
        RR = LL + editor_width
        B0 = T0 - (border + widget_rim + widget_rim) * 2 - SIZE_widget[0] * row_count_info - min(SIZE_widget[2], SIZE_widget[0])
        T1 = B0 - border_inner
        B1 = T1 - AreaKeymapCatch.r_height(None, None)
        T2 = B1 - border_inner
        B2 = T2 - (border + widget_rim + widget_rim) * 2 - SIZE_widget[0] * row_count_info_check_repeat
        # >>>

        self.areas[0].upd_size(LL, RR, B0, T0)
        self.areas[1].upd_size(LL, RR, B1, T1)
        self.areas[2].upd_size(LL, RR, B2, T2)
        #|

    def update_keymap_info(self):
        km = self.km
        a = self.areas[
            # <<< 1copy (0ed_KeymapEditor_AREAIND_catch,, $$)
            1
            # >>>
        ]
        self.keyinfo = r_keyinfo(P.keymaps.bl_rna.properties[a.trigger_id], a.trigger_id, a.trigger_index)
        self.areas[
            # <<< 1copy (0ed_KeymapEditor_AREAIND_info,, $$)
            0
            # >>>
        ].from_string(self.keyinfo)
        #|
    def update_repeat_info(self, keycatch_list, current_id_index=None):
        self.keyinfo_check_repeat = r_keyrepeatinfo(keycatch_list, current_id_index)
        self.areas[
            # <<< 1copy (0ed_KeymapEditor_AREAIND_info_check_repeat,, $$)
            2
            # >>>
        ].from_string(self.keyinfo_check_repeat)
        #|
    #|
    #|


RNA_keyinfo = RnaString("keyinfo",
    name = "Keymap Info",
    description = "KeyMap Information.",
    subtype = "LINES",
    is_readonly = True)
RNA_keyinfo_check_repeat = RnaString("keyinfo_check_repeat",
    name = "Keymap Conflict Info",
    description = "KeyMap Conflict Information.",
    subtype = "LINES",
    is_readonly = True)


## _import_lv2_ ##
def _import_lv2_():
    #|
    from . areas import (
        AreaSettingHeader,
        AreaSettingList,
        AreaBlockTabSettingEditor,
        AreaKeymapCatch,
    )

    from ... area import AreaStringXYPre
    from ... block import BlockFull, PREF_HISTORY
    from ... keysys import (
        kill_evt_except,
        MOUSE,
        EVT_TYPE,
        TRIGGER,
        TRIGGER_END,
        TRIGGER_IND,
        KEYMAPS,
        r_keyinfo,
        r_keyrepeatinfo,
    )
    from ... m import (
        P,
        W_DRAW,
        bring_draw_to_top_safe,
    )

    from ... utilbl import blg
    from ... utilbl.blg import (
        FONT0,
        D_SIZE,
        SIZE_widget,
        SIZE_border,
        SIZE_dd_border,
        SIZE_block,
        report,
    )

    globals().update(locals())
    #|
