import bpy
from bpy.types import Panel

P = None

class VmdPanel(Panel):
    __slots__ = ()

    bl_idname = "VMD_PT_Panel"
    bl_label = "Control Panel"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "VMD"

    def __init__(self):
        global P
        # <<< 1copy (assignP,, $$)
        P = bpy.context.preferences.addons[__package__].preferences
        # >>>
        #|

    def draw(self, context):
        #|
        layout = self.layout
        row = layout.row
        sep = layout.separator

        row().operator("wm.vmd_window_manager", text="Window Manager")

        for name in EDITORS:
            e = row().operator("wm.vmd_editor", text=name)
            e.id_class = name
            e.use_pos = False

        sep()
        row().operator("wm.save_userpref")
        row().operator("wm.vmd_addon_factory", text="Load Addon Factory Setting")
        row().operator("wm.vmd_reload_icon", text="Reload Icon")
        row().operator("wm.vmd_reload_font", text="Reload Font")






















        #|
    #|
    #|

class VmdPanelTemp(Panel):
    bl_idname = "VMD_TEMP_PT_Panel"
    bl_label = "Temporary Data"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "Item"
    bl_parent_id = "VMD_PT_Panel"

    @classmethod
    def poll(self, context):
        if Admin.IS_RUNNING:
            if W_MODAL: return True

        return False
        #|

    def draw(self, context):
        #|
        row = self.layout.row
        PP = P.temp

        # <<< 1ifmatch (0prefs_temp, 8,
        #     $lambda line: (f'row().prop(PP, "{line.split(":", 1)[0].lstrip()}")\n', True)$,
        #     $lambda line: ('', False)  if line.find('#sep()') == -1 else ('sep()\n', True)$,
        #     ${'Property('}$)
        row().prop(PP, "pos")
        row().prop(PP, "size")
        row().prop(PP, "canvas")
        # >>>
        #|
    #|
    #|
class VmdPanelGeneral(Panel):
    bl_idname = "VMD_GENERAL_PT_Panel"
    bl_label = "General"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "Item"
    bl_parent_id = "VMD_PT_Panel"

    def draw(self, context):
        #|
        layout = self.layout
        row = layout.row
        sep = layout.separator

        # <<< 1ifmatch (0prefs, 8,
        #     $lambda line: (f'row().split(factor=1.0).prop(P, "{line.split(":", 1)[0].lstrip()}")\n', True
        #         )  if line.find('PointerProperty') == -1 else ('', False)$,
        #     $lambda line: ('', False)  if line.find('#sep()') == -1 else ('sep()\n', True)$,
        #     ${'Property('}$)
        row().split(factor=1.0).prop(P, "npanel_reg_settings")
        row().split(factor=1.0).prop(P, "sys_auto_off")
        row().split(factor=1.0).prop(P, "show_length_unit")
        row().split(factor=1.0).prop(P, "lock_win_size")
        row().split(factor=1.0).prop(P, "lock_list_size")
        row().split(factor=1.0).prop(P, "th_drag")
        row().split(factor=1.0).prop(P, "th_double_click")
        row().split(factor=1.0).prop(P, "win_check_overlap")
        row().split(factor=1.0).prop(P, "win_overlap_offset")
        row().split(factor=1.0).prop(P, "filter_match_case")
        row().split(factor=1.0).prop(P, "filter_match_whole_word")
        row().split(factor=1.0).prop(P, "filter_match_end")
        row().split(factor=1.0).prop(P, "filter_autopan_active")
        row().split(factor=1.0).prop(P, "filter_adaptive_selection")
        row().split(factor=1.0).prop(P, "filter_delete_behavior")
        row().split(factor=1.0).prop(P, "cursor_beam_time")
        row().split(factor=1.0).prop(P, "use_select_all")
        row().split(factor=1.0).prop(P, "pan_invert")
        row().split(factor=1.0).prop(P, "scroll_distance")
        row().split(factor=1.0).prop(P, "valbox_drag_fac_int")
        row().split(factor=1.0).prop(P, "valbox_drag_fac_float")
        row().split(factor=1.0).prop(P, "button_repeat_time")
        row().split(factor=1.0).prop(P, "button_repeat_interval")
        row().split(factor=1.0).prop(P, "use_py_exp")
        row().split(factor=1.0).prop(P, "show_rm_keymap")
        row().split(factor=1.0).prop(P, "adaptive_enum_input")
        row().split(factor=1.0).prop(P, "adaptive_win_resize")
        row().split(factor=1.0).prop(P, "undo_steps_local")
        row().split(factor=1.0).prop(P, "format_float")
        row().split(factor=1.0).prop(P, "format_hex")
        row().split(factor=1.0).prop(P, "anim_filter")
        row().split(factor=1.0).prop(P, "animtime_filter")
        row().split(factor=1.0).prop(P, "cursor_picker")
        row().split(factor=1.0).prop(P, "cursor_pan")
        row().split(factor=1.0).prop(P, "md_lib_filepath")
        row().split(factor=1.0).prop(P, "md_lib_filter")
        row().split(factor=1.0).prop(P, "md_lib_method")
        row().split(factor=1.0).prop(P, "md_lib_use_essentials")
        row().split(factor=1.0).prop(P, "preview_scale")
        row().split(factor=1.0).prop(P, "preview_showname")
        row().split(factor=1.0).prop(P, "prop_image_dd_showicon")
        row().split(factor=1.0).prop(P, "fontpath_method")
        row().split(factor=1.0).prop(P, "fontpath_ui")
        row().split(factor=1.0).prop(P, "fontpath_ui_mono")
        row().split(factor=1.0).prop(P, "is_open_driver_editor")
        row().split(factor=1.0).prop(P, "blocklist_column_len")
        # >>>
        #|
    #|
    #|
class VmdPanelSize(Panel):
    bl_idname = "VMD_SIZE_PT_Panel"
    bl_label = "Size"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "Item"
    bl_parent_id = "VMD_PT_Panel"

    def draw(self, context):
        #|
        layout = self.layout
        row = layout.row
        sep = layout.separator
        PP = P.size

        layout.label(text='Press "Reload Icon" after changing UI size', icon="INFO")
        layout.label(text="This behavior will be performed automatically in the Settings Editor")
        row().operator("wm.vmd_reload_icon", text="Reload Icon")
        sep()
        row().operator("wm.vmd_ui_scale", text="Set UI Scale to 1.0").factor = 1.0
        row().operator("wm.vmd_ui_scale", text="Set UI Scale to 1.33").factor = 1.33
        row().operator("wm.vmd_ui_scale", text="Set UI Scale to 1.66").factor = 1.66
        row().operator("wm.vmd_ui_scale", text="Set UI Scale to 2.0").factor = 2.0
        sep()

        # <<< 1ifmatch (0prefs_size, 8,
        #     $lambda line: (f'row().split(factor=1.0).prop(PP, "{line.split(":", 1)[0].lstrip()}")\n', True)$,
        #     $lambda line: ('', False)  if line.find('#sep()') == -1 else ('sep()\n', True)$,
        #     ${'Property('}$)
        row().split(factor=1.0).prop(PP, "widget")
        row().split(factor=1.0).prop(PP, "title")
        row().split(factor=1.0).prop(PP, "border")
        row().split(factor=1.0).prop(PP, "dd_border")
        row().split(factor=1.0).prop(PP, "filter")
        row().split(factor=1.0).prop(PP, "tb")
        row().split(factor=1.0).prop(PP, "win_shadow_offset")
        row().split(factor=1.0).prop(PP, "dd_shadow_offset")
        row().split(factor=1.0).prop(PP, "shadow_softness")
        row().split(factor=1.0).prop(PP, "setting_list_border")
        row().split(factor=1.0).prop(PP, "block")
        row().split(factor=1.0).prop(PP, "button")
        row().split(factor=1.0).prop(PP, "foreground")
        row().split(factor=1.0).prop(PP, "foreground_height")
        row().split(factor=1.0).prop(PP, "widget_fac")
        # >>>
        #|
    #|
    #|
class VmdPanelColor(Panel):
    bl_idname = "VMD_COLOR_PT_Panel"
    bl_label = "Color"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "Item"
    bl_parent_id = "VMD_PT_Panel"

    def draw(self, context):
        #|
        layout = self.layout
        row = layout.row
        sep = layout.separator
        PP = P.color

        layout.label(text="This category does not provide a", icon="INFO")
        layout.label(text="correct color space preview,")
        layout.label(text="to preview accurate results please go")
        layout.label(text="to the Settings Editor >")
        layout.label(text="Personalization > UI Color")

        for k in PP.__annotations__:
            row().prop(PP, k)
        #|
    #|
    #|
class VmdPanelModifierEditor(Panel):
    bl_idname = "VMD_MODIFIER_EDITOR_PT_Panel"
    bl_label = "Modifier Editor"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "Item"
    bl_parent_id = "VMD_PT_Panel"

    def draw(self, context):
        #|
        layout = self.layout
        row = layout.row
        sep = layout.separator
        PP = P.ModifierEditor

        for k in PP.__annotations__:
            row().split(factor=1.0).prop(PP, k)
        #|
    #|
    #|
class VmdPanelSettingEditor(Panel):
    bl_idname = "VMD_SETTING_EDITOR_PT_Panel"
    bl_label = "Settings Editor"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "Item"
    bl_parent_id = "VMD_PT_Panel"

    def draw(self, context):
        #|
        layout = self.layout
        row = layout.row
        sep = layout.separator
        PP = P.SettingEditor

        for k in PP.__annotations__:
            row().split(factor=1.0).prop(PP, k)
        #|
    #|
    #|


## _file_ ##
def _import_():
    #|
    from . userops import EDITORS
    from . m import Admin, W_MODAL

    globals().update(locals())
    #|
